# -*- encoding: utf-8 -*-
require 'net/http'
require 'uri'

playlist_url, flv_dir, flv_retry = ARGV

exit if playlist_url.nil?
flv_dir = '.' if flv_dir.nil?
flv_retry = '10' if flv_retry.nil?

stream_url = Net::HTTP.get(URI.parse(playlist_url))

url = URI.parse(stream_url)

peca_id = url.path.split('/')[2].split('.')[0]

flv_retry.to_i.times do
	Dir.mkdir(flv_dir) unless Dir.exist?(flv_dir)
	file_name = "#{flv_dir}/#{(Time.now.to_f * 1000).to_i}.flv"
	puts file_name

	bytes = []

	begin
		Net::HTTP.start(url.host, url.port) do |http|
			http.request_get(url.path) do |request|
				bytesize = 0
				pos = 12
				chars = []
				data_size = -11
				first_time_stamp = nil

				request.read_body do |data|
					data.each_char.with_index do |char, i|
						chars.push(char)

						case bytesize + i
						when pos
							previous_tag_size = chars[-4, 4].join.unpack('N').first
							tag_size = data_size + 11

							unless previous_tag_size == tag_size
								chars[-4, 4] = [tag_size].pack('N').chars
							end

							if chars.length == data_size + 15 || pos == 12
								bytes += chars
							end

							chars = []
						when pos + 12
							tag_type = chars[0].ord & 0x1f

							unless [8, 9, 18].include?(tag_type)
								raise
							end

							data_size = (["\0"] + chars[1, 3]).join.unpack('N').first

							pos += data_size + 15

							time_stamp = (chars[7, 1] + chars[4, 3]).join.unpack('N').first

							stream_id = (["\0"] + chars[8, 3]).join.unpack('N').first

							unless stream_id == 0
								raise
							end

							if first_time_stamp.nil? && time_stamp > 0
								if tag_type == 9 && chars[11].ord >> 4 == 1
									first_time_stamp = time_stamp
								else
									chars = []
								end
							end

							if first_time_stamp.class == Fixnum
								setchars = [time_stamp - first_time_stamp].pack('N').chars
								chars[7] = setchars[0]
								chars[4, 3] = setchars[1, 3]
							end
						end
					end

					bytesize += data.bytesize

					unless bytes.empty?
						open(file_name, 'ab') do |f|
							f.write(bytes.join)
						end

						bytes = []
					end
				end
			end
		end
	rescue
		unless bytes.empty?
			open(file_name, 'ab') do |f|
				f.write(bytes.join)
			end
		end

		bytes = []

		Net::HTTP.get(url.host, "/admin?cmd=bump&id=#{peca_id}", url.port)

		sleep(3)
	end
end
